package sun.io;

public abstract class ByteToCharEUC extends ByteToCharConverter {
   // $FF: renamed from: G0 int
   private final int field_0;
   // $FF: renamed from: G1 int
   private final int field_1 = 1;
   private final int SS2 = 142;
   private final int SS3 = 143;
   private int firstByte;
   private int state = 0;
   protected String mappingTableG1;
   protected String byteToCharTable;

   public int flush(char[] var1, int var2, int var3) throws MalformedInputException {
      if (this.state != 0) {
         this.reset();
         super.badInputLength = 0;
         throw new MalformedInputException();
      } else {
         this.reset();
         return 0;
      }
   }

   public void reset() {
      this.state = 0;
      super.charOff = super.byteOff = 0;
   }

   public int convert(byte[] var1, int var2, int var3, char[] var4, int var5, int var6) throws UnknownCharacterException, MalformedInputException, ConversionBufferFullException {
      char var8 = '�';
      super.byteOff = var2;

      for(super.charOff = var5; super.byteOff < var3; ++super.byteOff) {
         int var7 = var1[super.byteOff];
         if (var7 < 0) {
            var7 += 256;
         }

         switch (this.state) {
            case 0:
               if (var7 == 142 || var7 == 143) {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               if (var7 <= 159) {
                  var8 = this.byteToCharTable.charAt(var7);
               } else {
                  if (var7 < 161 || var7 > 254) {
                     super.badInputLength = 1;
                     throw new MalformedInputException();
                  }

                  this.firstByte = var7;
                  this.state = 1;
               }
               break;
            case 1:
               this.state = 0;
               if (var7 < 161 || var7 > 254) {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               var8 = this.mappingTableG1.charAt((this.firstByte - 161) * 94 + var7 - 161);
         }

         if (this.state == 0) {
            if (var8 == '�') {
               if (!super.subMode) {
                  super.badInputLength = 1;
                  throw new UnknownCharacterException();
               }

               var8 = super.subChars[0];
            }

            if (super.charOff >= var6) {
               throw new ConversionBufferFullException();
            }

            var4[super.charOff++] = var8;
         }
      }

      return super.charOff - var5;
   }
}
