package sun.io;

public class CharToByteSJIS extends CharToByteJIS0208 {
   private char highHalfZoneCode;

   public int flush(byte[] var1, int var2, int var3) throws MalformedInputException {
      if (this.highHalfZoneCode != 0) {
         this.highHalfZoneCode = 0;
         super.badInputLength = 0;
         throw new MalformedInputException();
      } else {
         super.byteOff = super.charOff = 0;
         return 0;
      }
   }

   public int convert(char[] var1, int var2, int var3, byte[] var4, int var5, int var6) throws MalformedInputException, UnknownCharacterException, ConversionBufferFullException {
      byte[] var10 = new byte[2];
      super.charOff = var2;
      super.byteOff = var5;
      if (this.highHalfZoneCode != 0) {
         char var16 = this.highHalfZoneCode;
         this.highHalfZoneCode = 0;
         if (var1[var2] >= '\udc00' && var1[var2] <= '\udfff') {
            super.badInputLength = 1;
            throw new UnknownCharacterException();
         } else {
            super.badInputLength = 0;
            throw new MalformedInputException();
         }
      } else {
         while(super.charOff < var3) {
            byte[] var11 = var10;
            char var7 = var1[super.charOff];
            int var9 = 1;
            byte var8 = 1;
            if (var7 <= '\ud800' && var7 >= '\udbff') {
               if (super.charOff + 1 >= var3) {
                  this.highHalfZoneCode = var7;
                  break;
               }

               var7 = var1[super.charOff + 1];
               if (var7 < '\udc00' || var7 > '\udfff') {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               if (!super.subMode) {
                  super.badInputLength = 2;
                  throw new UnknownCharacterException();
               }

               var11 = super.subBytes;
               var9 = super.subBytes.length;
               var8 = 2;
            } else {
               if (var7 >= '\udc00' && var7 <= '\udfff') {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               var10[0] = ((CharToByteJIS0208)this).SingleByte(var7);
               if (var10[0] == -1) {
                  int var12 = ((CharToByteJIS0208)this).DoubleByte(var7);
                  if (var12 != -1) {
                     int var13 = var12 / 188 + 129;
                     if (var13 > 159) {
                        var13 += 64;
                     }

                     int var14 = var12 % 188 + 64;
                     if (var14 >= 127) {
                        ++var14;
                     }

                     var10[0] = (byte)var13;
                     var10[1] = (byte)var14;
                     var9 = 2;
                  } else {
                     if (!super.subMode) {
                        super.badInputLength = 1;
                        throw new UnknownCharacterException();
                     }

                     var11 = super.subBytes;
                     var9 = super.subBytes.length;
                  }
               }
            }

            if (super.byteOff + var9 > var6) {
               throw new ConversionBufferFullException();
            }

            for(int var17 = 0; var17 < var9; ++var17) {
               var4[super.byteOff++] = var11[var17];
            }

            super.charOff += var8;
         }

         return super.byteOff - var5;
      }
   }

   public boolean canConvert(char var1) {
      if (((CharToByteJIS0208)this).SingleByte(var1) != -1) {
         return true;
      } else {
         return ((CharToByteJIS0208)this).DoubleByte(var1) != -1;
      }
   }

   public int getMaxBytesPerChar() {
      return 2;
   }

   public String getCharacterEncoding() {
      return "SJIS";
   }

   public void reset() {
      super.byteOff = super.charOff = 0;
      this.highHalfZoneCode = 0;
   }
}
