package sun.io;

public abstract class ByteToCharDBCS_ASCII extends ByteToCharConverter {
   private boolean savedBytePresent = false;
   private byte savedByte;
   protected String singleByteToChar;
   protected boolean[] leadByte;
   protected short[] index1;
   protected String index2;
   protected int mask1;
   protected int mask2;
   protected int shift;

   public int flush(char[] var1, int var2, int var3) throws MalformedInputException {
      if (this.savedBytePresent) {
         this.reset();
         super.badInputLength = 0;
         throw new MalformedInputException();
      } else {
         this.reset();
         return 0;
      }
   }

   public int convert(byte[] var1, int var2, int var3, char[] var4, int var5, int var6) throws UnknownCharacterException, MalformedInputException, ConversionBufferFullException {
      char var8 = '�';
      super.charOff = var5;

      int var7;
      for(super.byteOff = var2; super.byteOff < var3; super.byteOff += var7) {
         int var9;
         if (!this.savedBytePresent) {
            var9 = var1[super.byteOff];
            var7 = 1;
         } else {
            var9 = this.savedByte;
            this.savedBytePresent = false;
            var7 = 0;
         }

         if (var9 < 0) {
            var9 += 256;
         }

         if (!this.leadByte[var9]) {
            var8 = this.singleByteToChar.charAt(var9);
         } else {
            if (super.byteOff + var7 >= var3) {
               this.savedByte = (byte)var9;
               this.savedBytePresent = true;
               super.byteOff += var7;
               break;
            }

            int var10 = var1[super.byteOff + var7];
            if (var10 < 0) {
               var10 += 256;
            }

            ++var7;
            int var11 = var9 * 256 + var10;
            var8 = this.index2.charAt(this.index1[(var11 & this.mask1) >> this.shift] + (var11 & this.mask2));
         }

         if (var8 == '�') {
            if (!super.subMode) {
               super.badInputLength = var7;
               throw new UnknownCharacterException();
            }

            var8 = super.subChars[0];
         }

         if (super.charOff >= var6) {
            throw new ConversionBufferFullException();
         }

         var4[super.charOff++] = var8;
      }

      return super.charOff - var5;
   }

   public void reset() {
      super.charOff = super.byteOff = 0;
      this.savedBytePresent = false;
   }
}
