package sun.io;

public class ByteToCharMacGreek extends ByteToCharSingleByte {
   private final char[] byteToCharTable = new char[]{'Ä', '¹', '²', 'É', '³', 'Ö', 'Ü', '΅', 'à', 'â', 'ä', '΄', '¨', 'ç', 'é', 'è', 'ê', 'ë', '£', '™', 'î', 'ï', '•', '½', '‰', 'ô', 'ö', '¦', '\u00ad', 'ù', 'û', 'ü', '†', 'Γ', 'Δ', 'Θ', 'Λ', 'Ξ', 'Π', 'ß', '®', '©', 'Σ', 'Ϊ', '§', '≠', '°', '·', 'Α', '±', '≤', '≥', '¥', 'Β', 'Ε', 'Ζ', 'Η', 'Ι', 'Κ', 'Μ', 'Φ', 'Ϋ', 'Ψ', 'Ω', 'ά', 'Ν', '¬', 'Ο', 'Ρ', '≈', 'Τ', '«', '»', '…', ' ', 'Υ', 'Χ', 'Ά', 'Έ', 'œ', '–', '―', '“', '”', '‘', '’', '÷', 'Ή', 'Ί', 'Ό', 'Ύ', 'έ', 'ή', 'ί', 'ό', 'Ώ', 'ύ', 'α', 'β', 'ψ', 'δ', 'ε', 'φ', 'γ', 'η', 'ι', 'ξ', 'κ', 'λ', 'μ', 'ν', 'ο', 'π', 'ώ', 'ρ', 'σ', 'τ', 'θ', 'ω', 'ς', 'χ', 'υ', 'ζ', 'ϊ', 'ϋ', 'ΐ', 'ΰ', '�', '\u0000', '\u0001', '\u0002', '\u0003', '\u0004', '\u0005', '\u0006', '\u0007', '\b', '\t', '\n', '\u000b', '\f', '\r', '\u000e', '\u000f', '\u0010', '\u0011', '\u0012', '\u0013', '\u0014', '\u0015', '\u0016', '\u0017', '\u0018', '\u0019', '\u001a', '\u001b', '\u001c', '\u001d', '\u001e', '\u001f', ' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\u007f'};

   public String getCharacterEncoding() {
      return "MacGreek";
   }

   public ByteToCharMacGreek() {
      super.byteToCharTable = this.byteToCharTable;
   }
}
