package sun.io;

public class ByteToCharSJIS extends ByteToCharJIS0208 {
   private static final boolean[] leadByte = new boolean[]{false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, false, false, false};
   private static final boolean[] secondByte = new boolean[]{false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, false, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, false, false, false};
   private static final char[] singleByteToChar = new char[]{'\u0000', '\u0001', '\u0002', '\u0003', '\u0004', '\u0005', '\u0006', '\u0007', '\b', '\t', '\n', '\u000b', '\f', '\r', '\u000e', '\u000f', '\u0010', '\u0011', '\u0012', '\u0013', '\u0014', '\u0015', '\u0016', '\u0017', '\u0018', '\u0019', '\u001a', '\u001b', '\u001c', '\u001d', '\u001e', '\u001f', ' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\u007f', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '｡', '｢', '｣', '､', '･', 'ｦ', 'ｧ', 'ｨ', 'ｩ', 'ｪ', 'ｫ', 'ｬ', 'ｭ', 'ｮ', 'ｯ', 'ｰ', 'ｱ', 'ｲ', 'ｳ', 'ｴ', 'ｵ', 'ｶ', 'ｷ', 'ｸ', 'ｹ', 'ｺ', 'ｻ', 'ｼ', 'ｽ', 'ｾ', 'ｿ', 'ﾀ', 'ﾁ', 'ﾂ', 'ﾃ', 'ﾄ', 'ﾅ', 'ﾆ', 'ﾇ', 'ﾈ', 'ﾉ', 'ﾊ', 'ﾋ', 'ﾌ', 'ﾍ', 'ﾎ', 'ﾏ', 'ﾐ', 'ﾑ', 'ﾒ', 'ﾓ', 'ﾔ', 'ﾕ', 'ﾖ', 'ﾗ', 'ﾘ', 'ﾙ', 'ﾚ', 'ﾛ', 'ﾜ', 'ﾝ', 'ﾞ', 'ﾟ', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�', '�'};
   private byte savedFirst;

   public int flush(char[] var1, int var2, int var3) throws MalformedInputException {
      if (this.savedFirst != 0) {
         this.savedFirst = 0;
         super.badInputLength = 0;
         throw new MalformedInputException();
      } else {
         super.byteOff = super.charOff = 0;
         return 0;
      }
   }

   public int convert(byte[] var1, int var2, int var3, char[] var4, int var5, int var6) throws UnknownCharacterException, MalformedInputException, ConversionBufferFullException {
      byte[] var13 = var1;
      super.byteOff = var2;
      if (this.savedFirst != 0) {
         if (!secondByte[var1[0] & 255]) {
            super.badInputLength = 0;
            throw new MalformedInputException();
         }

         byte[] var14 = new byte[var3 - var2 + 1];
         var14[0] = this.savedFirst;
         System.arraycopy(var1, var2, var14, 1, var3 - var2);
         --super.byteOff;
         var13 = var14;
         var2 = 0;
         var3 = var14.length;
         this.savedFirst = 0;
      }

      super.charOff = var5;

      byte var9;
      for(int var12 = var2; var12 < var3; super.byteOff += var9) {
         int var7 = var13[var12];
         if (var7 < 0) {
            var7 += 256;
         }

         char var11;
         if (leadByte[var7]) {
            var9 = 2;
            if (var12 + 1 >= var3) {
               this.savedFirst = (byte)var7;
               ++super.byteOff;
               break;
            }

            int var8 = var13[var12 + 1];
            if (var8 < 0) {
               var8 += 256;
            }

            if (!secondByte[var8]) {
               super.badInputLength = 2;
               throw new MalformedInputException();
            }

            if (var7 == 129 && var8 == 95) {
               var11 = '＼';
            } else {
               if (var7 >= 224) {
                  var7 -= 64;
               }

               var7 -= 129;
               if (var8 >= 127) {
                  --var8;
               }

               var8 -= 64;
               int var10 = var7 * 188 + var8;

               try {
                  var11 = super.jisx0208Chars[var10];
               } catch (ArrayIndexOutOfBoundsException var15) {
                  var11 = '�';
               }
            }
         } else {
            var9 = 1;
            var11 = singleByteToChar[var7];
         }

         if (var11 == '�') {
            if (!super.subMode) {
               super.badInputLength = var9;
               throw new UnknownCharacterException();
            }

            var11 = super.subChars[0];
         }

         if (super.charOff >= var6) {
            throw new ConversionBufferFullException();
         }

         var4[super.charOff++] = var11;
         var12 += var9;
      }

      return super.charOff - var5;
   }

   public String getCharacterEncoding() {
      return "SJIS";
   }

   public void reset() {
      super.byteOff = super.charOff = 0;
      this.savedFirst = 0;
   }
}
